version: '2'
services:
  flask_app:
    container_name: flask_app
    build:
      context: .
      dockerfile: ./project/Dockerfile.dev
    image: flask_app
    networks:
      lb7_network:
        ipv4_address: '10.0.0.2'
    ports:
      - 5000:5000
      - 14000:14000 # for debugging
      # puerto para rabbit?
    environment:
      - FLASK_APP=app:create_app
      - FLASK_ENV=development #production#development
      - ENV=dev #prod#dev
      - SQLALCHEMY_DATABASE_URI=postgresql://postgres:postgres@postgres_db:5432/colorize_dev
      - MONGO_DATABASE_URI=mongodb://admin:admin@mongo_db:27017/ # user_predictions
      # Add RABBIT IP
      - RABBITMQ_IP=10.0.0.5
      - APP_SETTINGS=project.config.DevelopmentConfig #ProductionConfig#DevelopmentConfig
      - APP_VERSION=1.0.0
      - REMOTE_DEBUG=False # to activate testing debug
      - ELK_USER=elastic
      - ELK_PASSWORD=elastic
      - ELASTIC_HOST=100.24.108.36
    entrypoint: ["python3", "manage.py", "run", "-h", "0.0.0.0", "-p", "5000"] # 
    #entrypoint: ["python3", "manage.py", "run", "-h", "0.0.0.0", "-p", "5000", "--cert=/ca/aas_web_app_ssl.crt", "--key=/ca/aas_web_app_ssl.key"] # con ssl
    #entrypoint: ["python3", "-m", "ptvsd", "--host", "0.0.0.0", "--port", "14000", "manage.py", "run", "--no-reload", "-h", "0.0.0.0"] # para test
    #entrypoint: ["gunicorn", "--certfile", "/ca/aas_web_app_ssl.crt", "--keyfile", "/ca/aas_web_app_ssl.key", "-b", "0.0.0.0:5000", "app:create_app"] # prod con ssl
    volumes:
      - ./:/app
      - ./security/ca:/ca
    depends_on: 
      - postgres_db

  postgres_db:
    container_name: postgres_db
    build:
      context: ./project/db
      dockerfile: Dockerfile
    image: postgres
    networks:
      lb7_network:
        ipv4_address: '10.0.0.3'
    environment:
      - POSTGRES_USER=postgres
      - POSTGRES_PASSWORD=postgres
    volumes:
      - db-data:/var/lib/postgresql/data
    ports:
      - 5432

  mongo_db:
    container_name: mongo_db
    image: mongo:latest
    networks:
      lb7_network:
        ipv4_address: '10.0.0.6'
    environment:
      - MONGO_INITDB_DATABASE=user_predictions
      - MONGO_INITDB_ROOT_USERNAME=admin
      - MONGO_INITDB_ROOT_PASSWORD=admin
    volumes:
      - ./project/mongodb/init-mongo.js:/docker-entrypoint-initdb.d/init-mongo.js:ro
      - mongo-db-data:/data/db
    ports:
      - '27017-27019'
  
  predictor:
    container_name: predictor
    build:
      context: .
      dockerfile: predictor/Dockerfile
    image: predictor
    networks:
      lb7_network:
        ipv4_address: '10.0.0.4'
    environment:
      - PASSWORD=1234
      - RABBITMQ_IP=10.0.0.5
      - ELK_USER=elastic
      - ELK_PASSWORD=elastic
      - ELASTIC_HOST=100.24.108.36
    volumes:
      - ./predictor/:/app
      - ./security/ca:/ca
    entrypoint: ["python3", "/app/app.py"]
    #entrypoint: ["ls", "/app"]
    ports:
      - '5672'
      - '5671'
      - '8888:8888'

  rabbitmq:
    image: rabbitmq:management-alpine
    container_name: rabbitmq
    networks:
      lb7_network:
        ipv4_address: '10.0.0.5'
    volumes:
      - './security:/conf'
    ports:
      - '5672'
      - '5671'
      - '15672:15672'
      - '15671:15671'
    environment:
      - 'RABBITMQ_SSL_CACERTFILE=/conf/ca/aas_ca.crt'
      - 'RABBITMQ_SSL_CERTFILE=/conf/ca/aas_rabbitmq_ssl.crt'
      - 'RABBITMQ_SSL_KEYFILE=/conf/ca/aas_rabbitmq_ssl.key'
      - 'RABBITMQ_SSL_FAIL_IF_NO_PEER_CERT=true'
      - 'RABBITMQ_SSL_VERIFY=verify_peer'
  
volumes:
  db-data:
    driver: local
  mongo-db-data:
    driver: local
networks:
  lb7_network:
    driver: bridge
    ipam:
      driver: default
      config:
        - subnet: '10.0.0.0/24'
